Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| OptaPlanner distribution 6.1.0.CR1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.optaplanner.core.impl.domain.solution.descriptor
Class SolutionDescriptor

    java.lang.Object
      org.optaplanner.core.impl.domain.solution.descriptor.SolutionDescriptor

    public class SolutionDescriptor

extends Object

Field Summary
`protected org.slf4j.Logger` | `logger`

Constructor Summary
`SolutionDescriptor(Class<? extends Solution> solutionClass)`

Method Summary
`void` | `addEntityDescriptor(EntityDescriptor entityDescriptor)`
`void` | `afterAnnotationsProcessed(DescriptorPolicy descriptorPolicy)`
`VariableListenerSupport` | `buildVariableListenerSupport()`
`int` | `countUninitializedVariables(Solution solution)`
`GenuineVariableDescriptor` | `findGenuineVariableDescriptor(Object entity, String variableName)`
`VariableDescriptor` | `findVariableDescriptor(Object entity, String variableName)`
`Collection<Object>` | `getAllFacts(Solution solution)`
`Collection<GenuineVariableDescriptor>` | `getChainedVariableDescriptors()`
`Set<Class<?>>` | `getEntityClassSet()`
`Map<String,PropertyAccessor>` | `getEntityCollectionPropertyAccessorMap()`
`int` | `getEntityCount(Solution solution)`
`EntityDescriptor` | `getEntityDescriptor(Class<?> entitySubclass)`
`Collection<EntityDescriptor>` | `getEntityDescriptors()`
`EntityDescriptor` | `getEntityDescriptorStrict(Class<?> entityClass)`
`List<Object>` | `getEntityList(Solution solution)`
`List<Object>` | `getEntityListByEntityClass(Solution solution, Class<?> entityClass)`
`Map<String,PropertyAccessor>` | `getEntityPropertyAccessorMap()`
`Collection<EntityDescriptor>` | `getGenuineEntityDescriptors()`
`long` | `getProblemScale(Solution solution)` Calculates an indication on how big this problem instance is.
`PropertyAccessor` | `getPropertyAccessor(String propertyName)`
`Class<? extends Solution>` | `getSolutionClass()`
`SolutionCloner` | `getSolutionCloner()`
`int` | `getValueCount(Solution solution)`
`boolean` | `hasEntityDescriptor(Class<?> entitySubclass)`
`boolean` | `hasEntityDescriptorStrict(Class<?> entityClass)`
`boolean` | `isInitialized(ScoreDirector scoreDirector, Solution solution)`
`void` | `processAnnotations(DescriptorPolicy descriptorPolicy)`
`String` | `toString()`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### logger

    protected final transient org.slf4j.Logger logger

Constructor Detail

### SolutionDescriptor

    public SolutionDescriptor(Class<? extends Solution> solutionClass)

Method Detail

### addEntityDescriptor

    public void addEntityDescriptor(EntityDescriptor entityDescriptor)

### processAnnotations

    public void processAnnotations(DescriptorPolicy descriptorPolicy)

### afterAnnotationsProcessed

    public void afterAnnotationsProcessed(DescriptorPolicy descriptorPolicy)

### getSolutionClass

    public Class<? extends Solution> getSolutionClass()

### getSolutionCloner

    public SolutionCloner getSolutionCloner()

### getEntityPropertyAccessorMap

    public Map<String,PropertyAccessor> getEntityPropertyAccessorMap()

### getEntityCollectionPropertyAccessorMap

    public Map<String,PropertyAccessor> getEntityCollectionPropertyAccessorMap()

### getPropertyAccessor

    public PropertyAccessor getPropertyAccessor(String propertyName)

### getEntityClassSet

    public Set<Class<?>> getEntityClassSet()

### getEntityDescriptors

    public Collection<EntityDescriptor> getEntityDescriptors()

### getGenuineEntityDescriptors

    public Collection<EntityDescriptor> getGenuineEntityDescriptors()

### hasEntityDescriptorStrict

    public boolean hasEntityDescriptorStrict(Class<?> entityClass)

### getEntityDescriptorStrict

    public EntityDescriptor getEntityDescriptorStrict(Class<?> entityClass)

### hasEntityDescriptor

    public boolean hasEntityDescriptor(Class<?> entitySubclass)

### getEntityDescriptor

    public EntityDescriptor getEntityDescriptor(Class<?> entitySubclass)

### getChainedVariableDescriptors

    public Collection<GenuineVariableDescriptor> getChainedVariableDescriptors()

### buildVariableListenerSupport

    public VariableListenerSupport buildVariableListenerSupport()

### findGenuineVariableDescriptor

    public GenuineVariableDescriptor findGenuineVariableDescriptor(Object entity,
                                                                   String variableName)

### findVariableDescriptor

    public VariableDescriptor findVariableDescriptor(Object entity,
                                                     String variableName)

### getAllFacts

    public Collection<Object> getAllFacts(Solution solution)

### getEntityCount

    public int getEntityCount(Solution solution)

  Parameters:
    `solution` - never null
  Returns:
    >= 0

### getEntityList

    public List<Object> getEntityList(Solution solution)

### getEntityListByEntityClass

    public List<Object> getEntityListByEntityClass(Solution solution,
                                                   Class<?> entityClass)

### getValueCount

    public int getValueCount(Solution solution)

  Parameters:
    `solution` - never null
  Returns:
    >= 0

### getProblemScale

    public long getProblemScale(Solution solution)

  Calculates an indication on how big this problem instance is. This is intentionally very loosely defined for now.

  Parameters:
    `solution` - never null
  Returns:
    >= 0

### countUninitializedVariables

    public int countUninitializedVariables(Solution solution)

### isInitialized

    public boolean isInitialized(ScoreDirector scoreDirector,
                                 Solution solution)

  Parameters:
    `scoreDirector` - never null
    `solution` - never null
  Returns:
    true if all the movable planning entities are initialized

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| OptaPlanner distribution 6.1.0.CR1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2006-2014 JBoss by Red Hat. All Rights Reserved.